﻿package{
	
	import flash.display.Sprite;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Stage;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.geom.Matrix;
	
	public class IntuitiveDrawer extends Sprite{
		
		var bg:BitmapData;
		var container:Bitmap;
		var line:Sprite;
		var lineCopy:Sprite;
		var lineStack:Array;
		var matrix:Matrix;
		
		public function IntuitiveDrawer():void{
			
			bg = new BitmapData(stage.stageWidth,stage.stageHeight,false,0x000000);
			container = new Bitmap(bg);
			addChild(container);
			
			stage.addEventListener(MouseEvent.MOUSE_DOWN,startDessine);
			stage.addEventListener(MouseEvent.MOUSE_MOVE,dessine);
			stage.addEventListener(MouseEvent.MOUSE_UP,stopDessine);
		
			}
			
		private function startDessine(e:MouseEvent):void{
			removeEventListener(Event.ENTER_FRAME,floodit);
			matrix = new Matrix();
			line = new Sprite();
			lineStack = new Array();
			line.graphics.lineStyle(1,0xffffff,0.00001);
			line.graphics.moveTo(e.stageX,e.stageY);
			lineStack.push(new Array(e.stageX,e.stageY+4));
			}
			
			
		
		private function dessine(e:MouseEvent):void{
			if(line != null){
				//line.graphics.lineTo(e.stageX,e.stageY);
				lineStack.push(new Array(4,e.stageY+3));
				addChild(line);
				}
			}
		
		private function stopDessine(e:MouseEvent):void{
			if(line != null){
				removeChild(line);
				line = null;
				floodFill();
			}
		}
		
		private function floodFill():void{
			lineCopy= new Sprite();
			lineCopy.graphics.lineStyle(4,buildColor(),2);
			lineCopy.graphics.moveTo(lineStack[0][0],lineStack[0][1]);
			for(var i:uint=1;i<lineStack.length;i++){
				lineCopy.graphics.lineTo(lineStack[i][0],lineStack[i][1]);
				}
			addEventListener(Event.ENTER_FRAME,floodit);
			}
		private function floodit(e:Event):void{
			matrix.scale(0.9999,1.7);
			bg.draw(lineCopy,matrix);
			}
			
			
		/*construction d'une valeur STRING pour une couleur aléatoire*/
		private function buildColor():uint{
			var R:uint = (23,53,12);
			var G:uint = (0,34,34);
			var B:uint = (250,250,250);
			var nbr:uint =  R << 10 | G << 3 | B;
			return nbr;
			}
	}
	
}